> For the complete documentation index, see [llms.txt](https://superfluid.gitbook.io/superfluid/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://superfluid.gitbook.io/superfluid/developers/constant-flow-agreement-cfa/cfav1-library/read-methods.md).

# Read Methods

## Method Catalog

```solidity
/** CFA VIEW FUNCTIONS ************************************* */


function getFlowRate(ISuperToken token, address sender, address receiver)
    internal view returns(int96 flowRate);

function getFlowInfo(ISuperToken token, address sender, address receiver)
    internal view
    returns(uint256 lastUpdated, int96 flowRate, uint256 deposit, uint256 owedDeposit);

function getNetFlowRate(ISuperToken token, address account)
    internal view returns (int96 flowRate);

function getNetFlowInfo(ISuperToken token, address account)
    internal view returns (uint256 lastUpdated, int96 flowRate, uint256 deposit, uint256 owedDeposit);

function getBufferAmountByFlowRate(ISuperToken token, int96 flowRate) internal view
    returns (uint256 bufferAmount);

function getFlowPermissions(ISuperToken token, address sender, address flowOperator)
    internal view
    returns (bool allowCreate, bool allowUpdate, bool allowDelete, int96 flowRateAllowance);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://superfluid.gitbook.io/superfluid/developers/constant-flow-agreement-cfa/cfav1-library/read-methods.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
